package ch.hslu.dmg.g06.data;

import java.io.Serializable;
import java.util.List;

import javax.persistence.*;

@Entity
@Table(name = "Teil")
@NamedQueries({ @NamedQuery(name = "Part.getAll", query = "SELECT p FROM Part p"),
				@NamedQuery(name = "Part.getPartById", query = "SELECT p FROM Part p WHERE p.id = :id") })
public class Part  implements Serializable {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	@Id
	@GeneratedValue(strategy=GenerationType.IDENTITY)
	@Column(name = "Id")
	private int id;
	
	@JoinColumn(name = "LieferantId", referencedColumnName = "Id")
	@ManyToOne(optional = false)
	private Supplier supplier;
	
	@JoinColumn(name = "MaschineId", referencedColumnName = "Id")
	@ManyToOne
	private Machine machine;
	
	@Basic(optional = false)
	@Column(name = "Nummer")
	private int number;
	
	@Basic(optional = false)
	@Column(name = "Bezeichnung")
	private String description;
	
	@Basic(optional = false)
	@Column(name = "Preis")
	private float price;
	
	@Basic(optional = false)
	@Column(name = "Groesse")
	private float size;
	
	@ManyToMany
	@JoinTable(name="BestehtAus",
			   joinColumns={@JoinColumn(name="ElternteilId", referencedColumnName="Id")},
			   inverseJoinColumns={@JoinColumn(name="KindteilId", referencedColumnName="Id")})
	private List<Part> composedOf;

	
	public Part() {}
	
	public Part(int Id) {
		this.id = Id;
	}
	
	
	
	public int getId() {
		return id;
	}

	public void setId(int id) {
		this.id = id;
	}

	public Supplier getSupplier() {
		return supplier;
	}

	public void setSupplier(Supplier supplier) {
		this.supplier = supplier;
	}

	public Machine getMachine() {
		return machine;
	}

	public void setMachine(Machine machine) {
		this.machine = machine;
	}

	public int getNumber() {
		return number;
	}

	public void setNumber(int number) {
		this.number = number;
	}

	public String getDescription() {
		return description;
	}

	public void setDescription(String description) {
		this.description = description;
	}

	public float getPrice() {
		return price;
	}

	public void setPrice(float price) {
		this.price = price;
	}

	public float getSize() {
		return size;
	}

	public void setSize(float size) {
		this.size = size;
	}
	
	public List<Part> getComposedOf() {
		
		return composedOf;
	}
	
	@Override
	public String toString() {
		
		return "Teil (Id: " + id + ")";
		//return "Teil (Id " + id + "; Beschreibung " + description + ")";
	}
}
